#pragma once

#include "ParticipantUDP.h"

#if !defined(NO_STD)
#include <functional>
#include <memory>
#include <unordered_map>
#endif

namespace RoboidControl {

/// @brief A participant is device which can communicate with other participants
class SiteServer : public ParticipantUDP {
 public:
  SiteServer(int port = 7681);

  virtual void UpdateMyThings(unsigned long currentTimeMs) override;

 protected:
  unsigned long nextPublishMe = 0;

  virtual void Process(Participant* sender, ParticipantMsg* msg) override;
  virtual void Process(Participant* sender, SiteMsg* msg) override;
  virtual void Process(Participant* sender, ThingMsg* msg) override;
};

}  // namespace RoboidControl
